(function() {
    var ele = document.querySelector('#list');
    var eleTem = document.querySelector('#list-template');
    var loading = document.querySelector('#loading');
    if(!loading){
        ele.insertAdjacentHTML("afterEnd",'<div id="loading"></div>');
        loading = document.querySelector('#loading');
    }
    var list = function(params, callback) {
        this.params = {
                url: '',
                ajaxData: {
                    pageIndex: 0,
                    pageSize: 20
                }, //ajax请求的数据
                showloading:true, //是否开启首次加载动画
                eleId: '#list', //容器id
                temId: '#list-template', //模板id
                refresh: false //是否开启下拉刷新
            },
        this.isCanLoad = true, //防止上拉过快多次请求
        this.extend(this.params, params)
        this.init(callback);
    }
    list.prototype = {
        extend: function(a, b) {
            var that = this;
            for (var key in b) {
                if (b.hasOwnProperty(key)) {
                    if (typeof b[key] === "object") {
                        that.extend(a[key], b[key])
                    } else {
                        a[key] = b[key];
                    }
                }
            }
            ele = document.querySelector(a['eleId']);
            eleTem = document.querySelector(a['temId']);
        },
        init: function(callback) {
            var that = this;
            that.params.ajaxData.pageIndex = 0; //重置pageindex的值
            that.isCanLoad = true;
            loading.innerHTML = '';
            if(that.params.showloading){
                api.showProgress({
                    title: '',
                    text: ''
                });
            }
            ele.innerHTML = '<p class="aui-text-center aui-padded-10">努力加载中...</p>'
            api.ajax({
                url: that.params.url,
                method: 'post',
                cache: true,
                dataType: 'json',
                data: {
                    values: that.params.ajaxData
                }
            }, function(ret, err) {
                api.hideProgress(); //隐藏加载条
                if (ret) {
                    if (ret.status == 'ok') {
                      setTimeout(function(){
                        var tpl = eleTem.innerHTML;
                        ele.innerHTML = doT.template(tpl)(ret);
                        if (callback) {
                            callback(ret)
                        }
                        api.parseTapmode();
                        that.isMoreData(ret.pageCount, callback);
                      },500)
                    } else {
                        setTimeout(function(){
                          ele.style.background = 'transparent'; //将默认的背景色改为透明
                          ele.innerHTML = '<div style="margin-top: 2.5rem;text-align: center;"><img src="../../image/app_assets_images_home_card_nodate.png" style="width: 5rem;display:inline-block"><p>没有找到您要的数据</p></div>'
                        //没有数据时候的样式
                      },300)
                    }
                } else {
                    api.toast({
                        msg: err.msg,
                        duration: 2000,
                        location: 'middle'
                    })
                }
            });
        },
        isMoreData: function(pageCount, callback) {
            var that = this;
            if (!pageCount||pageCount == 1){
                return false;
            }
            that.getMoreData(callback);
        },
        getMoreData: function(callback) {
            var that = this;
            api.addEventListener({
                name: 'scrolltobottom',
                extra: {
                    threshold: 50 //设置距离底部多少距离时触发，默认值为0，数字类型
                }
            }, function(ret, err) {
                if (that.isCanLoad) {
                    that.isCanLoad = false;
                    loading.innerHTML = '<p class="aui-text-center aui-padded-10">努力加载中...</p>';
                    //防止速度过快多次调用接口导致出错
                    that.params.ajaxData.pageIndex = that.params.ajaxData.pageIndex + 1;
                    api.ajax({
                        url: that.params.url,
                        method: 'post',
                        cache: true,
                        dataType: 'json',
                        data: {
                            values: that.params.ajaxData
                        }
                    }, function(ret, err) {
                        setTimeout(function() {
                            loading.innerHTML = '';
                            if (ret) {
                                if (ret.status == 'ok') {
                                    that.isCanLoad = true;
                                    var tpl = eleTem.innerHTML;
                                    ele.insertAdjacentHTML("beforeEnd", doT.template(tpl)(ret));
                                    api.parseTapmode();
                                    if (callback) {
                                        callback(ret)
                                    }
                                } else {
                                    loading.innerHTML = '<p class="aui-text-center aui-padded-10">没有更多信息了</p>'
                                    api.removeEventListener({
                                        name: 'scrolltobottom'
                                    });
                                }
                            } else {
                                api.toast({
                                    msg: err.msg,
                                    duration: 2000,
                                    location: 'bottom'
                                })
                            }
                        }, 100)

                    })
                }
            })
        }
    }
    window.list = list;
})(window);
